/*
** spy_block_body.c
** Login : <julien@localhost>
** $Id$
** 
** Copyright Julien Perez (C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <stdlib.h>

#include "spy.h"
#include "http.h"
#include "conf.h"
#include "http_methods.h"
#include "vshlib.h"

static spy_key_t *content_keys = NULL;

int  spy_block_content_policy_rule (char *rule)
{
  int i, res = 0;
  vsh_str_t str;
  char *order;

  for (i = 0; rule[i] && isblank(rule[i]); i++) ;
  if (!rule[i])
    return 0;
  
  vsh_str_init(&str);
  for (i; rule[i] && !isblank(rule[i]); i++) 
    vsh_str_addchar(&str, rule[i]);

  order = vsh_str_inline(&str);
  vsh_str_free(&str);

  if (!strcmp("block", order))
    {
      content_keys = spy_key_add(content_keys, &rule[i]);
      res = 1;
    }

  vsh_free(order);
  return res;
}


int  spy_block_content_init()
{
  return 0;
}


int spy_block_content(void *data, int lenght, char *type, int log)
{
  int i, res;
  char body[HTTP_TRANSMIT_BUFFER_SIZE + 1]; // no malloc for speed but
					    // still secure

  if (!type || (type && strncmp(type, "text/", 5)))
    return 1;
  else
    {
      strncpy(body, (char*)data, lenght);
      body[lenght] = 0;
    }

  res = spy_key_fnmatch(content_keys, body);

  if (res)
    {
      if (log)
	spy_log("BLOCK_CONTENT", conf_get_node(CONF_LOG),0);
      return 0;
    }
  return 1;
}
