/*
** spy_filter_url.c
** Login : <julien@localhost>
** $Id$
** 
** Copyright Julien Perez (C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <stdlib.h>

#include "spy.h"
#include "conf.h"
#include "vshlib.h"
#include "http.h"


static spy_key_t *url_keys = NULL;
static int url_default_policy = 1;

int  spy_block_url_policy_rule (char *rule)
{
  int i, res = 0;
  vsh_str_t str;
  char *order;

  for (i = 0; rule[i] && isblank(rule[i]); i++) ;
  if (!rule[i])
    return 0;

  vsh_str_init(&str);
  for (i; rule[i] && !isblank(rule[i]); i++) 
    vsh_str_addchar(&str, rule[i]);

  order = vsh_str_inline(&str);
  vsh_str_free(&str);
  if (!strcmp("allow-all", order))
    {
      url_default_policy = POLICY_ALLOW_ALL;
      res = 1;
    }
  if (!strcmp("block-all", order))
    {
      url_default_policy = POLICY_BLOCK_ALL;
      res = 1;
    }
  if (!strcmp("allow", order))
    {
      if (url_default_policy == POLICY_BLOCK_ALL)
	url_keys = spy_key_add(url_keys, &rule[i]);
      res = 1;
    }
  if (!strcmp("block", order))
    {
      if (url_default_policy == POLICY_ALLOW_ALL)
	url_keys = spy_key_add(url_keys, &rule[i]);
      res = 1;
    }

  vsh_free(order);
  return res;
}


int  spy_block_url_init()
{
  return 1;
}


int spy_block_req_url(http_req_t *req, int log)
{
  int i, res;
  char *string;

  res = spy_key_fnmatch(url_keys, req->url);
  if (res)
    {
      if (url_default_policy == POLICY_BLOCK_ALL)
	return 1;
      else
	{
	  if (log)
	    spy_log("BLOCK_URL", conf_get_node(CONF_LOG), 1);
	  return 0;
	}
    }
  else
    {
      if (url_default_policy == POLICY_BLOCK_ALL)
	{
	  if (log)
	    spy_log("BLOCK_URL", conf_get_node(CONF_LOG), 1);
	  return 0;
	}
      else
	return 1;
    }
}
