/*
** spy_shape_shellcode.c
** 
** Copyright Julien Perez (C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/


#include "spy.h"
#include "conf.h"
#include "vshlib.h"
#include "http.h"
#include "http_methods.h"


static char filter_shellcode[] =
  {
    "/*-+=_(){}[]&~#\"'%?,;.:~@$"
  };



int  spy_shape_shellcode_policy_rule (char *rule)
{
  return 0;
}

int  spy_shape_shellcode_init()
{
  return 0;
}



static int spy_is_valid_char(char c)
{
  int i;
  
   if (isalnum(c))
    return 1;

   if (isblank(c))
     return 1;

  for (i = 0; filter_shellcode[i] && c != filter_shellcode[i]; i++) ;
  if (filter_shellcode[i] != 0)
    return 1;
  
  return 0;
}

int spy_shape_req_shellcode (http_req_t *req, int log)
{
  int i;
  http_field_t *tmp_field;


  /* URL Checking */
  for (i = 0; req->url[i]; i++)
    if (!spy_is_valid_char(req->url[i]))
      {
	req->url[i] = '\0';
	if (log)
	  spy_log("SHAPE_SHELLCODE", conf_get_node(CONF_LOG), 1);
	break ;
      }

  /* HTTP Headers Checking */
  for (tmp_field = req->lst_fields; tmp_field; tmp_field = tmp_field->next)
    {
      for (i = 0; tmp_field->value[i] && spy_is_valid_char(tmp_field->value[i]); i++) ;
      if (tmp_field->value[i])
	{
	  tmp_field->value[i] = '\0';
	  if (log)
	    spy_log("SHAPE_SHELLCODE", conf_get_node(CONF_LOG), 1);
	}
    }
  return 1;
}

int spy_shape_resp_shellcode (http_resp_t *resp, int log)
{
  int i;
  http_field_t *tmp_field;

  /* HTTP Headers Checking */
  for (tmp_field = resp->lst_fields; tmp_field; tmp_field = tmp_field->next)
    {
      for (i = 0; tmp_field->value[i] && spy_is_valid_char(tmp_field->value[i]); i++) ;
      if (tmp_field->value[i])
	{
	  tmp_field->value[i] = '\0';
	  if (log)
	    spy_log("SHAPE_SHELLCODE", conf_get_node(CONF_LOG), 0);
	}
    }
  return 1;
}

