/*
** spy_response.c
** 
** Copyright Julien Perez (C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <string.h>

#include "spy.h"

#include "http.h"
#include "http_methods.h"




static char *body_block =
"<html>\r\n"
"<head><title>403 Spyd Block</title></head>\r\n"
"<body>\r\n"
"<h1>403 Spyd identified Inappropriate Web Access </h1>\r\n"
"<p>Please contact your proxy administrator</p>\r\n"
"</body>\r\n"
"</html>\r\n";

static char *body_unreach =
"<html>\r\n"
"<head><title>404 Spyd Failed</title></head>\r\n"
"<body>\r\n"
"<h1>403 Spyd Failed resolving requesting domain </h1>\r\n"
"<p>Please contact your proxy administrator</p>\r\n"
"</body>\r\n"
"</html>\r\n";

static char *body_unconnect =
"<html>\r\n"
"<head><title>404 Spyd Failed</title></head>\r\n"
"<body>\r\n"
"<h1>403 Spyd Failed connecting requesting HTTP server </h1>\r\n"
"<p>Please contact your proxy administrator</p>\r\n"
"</body>\r\n"
"</html>\r\n";

/* Standard Blocking response */
void spy_response_block(http_resp_t *resp)
{
  resp->version = DEFAULT_HTTP_VERSION;
  resp->status = 403;

  
  resp->lst_fields = http_methods_add_field(resp->lst_fields, FLD_CONTENT_TYPE, "text/html");
  resp->lst_fields = http_methods_add_field(resp->lst_fields, FLD_PROXY_CONNECTION, "close");
  
  resp->body = strdup(body_block);
  resp->body_lenght = strlen(body_block);
}


/* Standard "server unreachable" response */
void spy_response_unreach(http_resp_t *resp)
{
  resp->version = DEFAULT_HTTP_VERSION;
  resp->status = 401;

  resp->lst_fields = http_methods_add_field(resp->lst_fields, FLD_CONTENT_TYPE, "text/html");
  resp->lst_fields = http_methods_add_field(resp->lst_fields, FLD_PROXY_CONNECTION, "close");
  
  resp->body = strdup(body_unreach);
  resp->body_lenght = strlen(body_unreach);
}

/* Standard "unable to connect" response */
void spy_response_unconnect(http_resp_t *resp)
{
  resp->version = DEFAULT_HTTP_VERSION;
  resp->status = 401;

  resp->lst_fields = http_methods_add_field(resp->lst_fields, FLD_CONTENT_TYPE, "text/html");
  resp->lst_fields = http_methods_add_field(resp->lst_fields, FLD_PROXY_CONNECTION, "close");
  
  resp->body = strdup(body_unconnect);
  resp->body_lenght = strlen(body_unconnect);
}
