/*
** vsh_io.c
**
** Copyright Julien Perez(C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <stdlib.h>
#include <stdio.h>

#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "vshlib.h"

int vsh_open(const char *pathname, int flags, boolean crit)
{
  int fd;

  fd = open(pathname, flags);
  if (fd == -1)
  {
    perror("open");
    if (crit)
      {
	vsh_log(FAC_ERROR, "vsh_open");
	exit(1);
      }
  }
  return fd;
}

int vsh_close(int fd)
{
  int res;
  
  if (fd < 0)
    return 0;
  
  res = close(fd);
  if (res == -1)
    {
    perror("close");
    //exit(1);
    }
  return res;
}

ssize_t vsh_read(int fd, void *buf, size_t count)
{
  ssize_t size;

  size = read(fd, buf, count);
  if (size == -1)
  {
    //perror("read");
    exit(1);
  }
  return size;
}

ssize_t vsh_write(int fd, const void *buf, size_t count)
{
  ssize_t size;

  size = write(fd, buf, count);
  if (size == -1)
  {
    perror("write");
    exit(1);
  }
  return size;
}


int     vsh_fstat(int filedes, struct stat *buf)
{
  int res;

  res = fstat(filedes, buf);
  if (res == -1)
  {
    perror("fstat");
    exit(1);
  }
  return res;
}
