/*
** vsh_process.c
** 
** Copyright Julien Perez (C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <stdlib.h>
#include <stdio.h>
#include <signal.h>

#include "vshlib.h"

int vsh_sigaction(int signum, const struct sigaction *act, struct sigaction *oldact)
{
  int res;

  res = sigaction(signum, act, oldact);
  if (res == -1)
    {
      perror("sigaction");
      exit(1);
    }
  return res;
}

void *vsh_malloc(size_t size)
{
  void *ptr;

  ptr = malloc(size);
  if (ptr == NULL)
    {
      perror("malloc");
      exit(1);
    }
  return ptr;
}

void    vsh_free (void *ptr)
{
  if (ptr != NULL)
    free(ptr);
}
