/*
** vsh_str.c
** 
** Copyright Julien Perez (C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <stdlib.h>

#include "vshlib.h"


void       vsh_str_init(vsh_str_t *str)
{
  str->head = NULL;
  str->tail = NULL;
  str->size = 0;
}

void vsh_str_addchar (vsh_str_t *str, char c)
{
  vsh_char_t *new;

  new = (vsh_char_t *)vsh_malloc(sizeof(vsh_char_t));
  new->next = NULL;
  new->c = c;

  if (str->size == 0)
    {
      str->head = new;
      str->tail = new;
    }
  else
    {
      str->tail->next = new;
      str->tail = new;
    }
  str->size++;
}

void vsh_str_addnchar (vsh_str_t *head, char *buf, int lenght)
{
  int i;
  
  for (i = 0; i < lenght; i++)
    vsh_str_addchar (head, buf[i]);
}

char  *vsh_str_inline  (vsh_str_t *str)
{
  int i;
  char *str_inline;
  vsh_char_t *tmp;

  if (str->size)
    {
      str_inline = (char*)vsh_malloc(str->size + 1);
      for (i = 0, tmp = str->head; tmp; i++, tmp = tmp->next)
	str_inline[i] = tmp->c;
      str_inline[str->size] = '\0';
      return str_inline;
    }
  return NULL;
}

void vsh_str_free(vsh_str_t *str)
{
  vsh_char_t *tmp, *tmp2;

  tmp = str->head;
  while (tmp) 
    {
      tmp2 = tmp->next;
      vsh_free(tmp);
      tmp = tmp2;
    }
  str->size = 0;
  str->head = NULL;
  str->tail = NULL;
}
